local S = superquest.S

local guide_form_name = core.get_current_modname()..":digilines_guide"

superquest.digilines = {
    send = {}
}

superquest.digilines.max_channel_length = 255

local formspec_guide_text = "==================================================\n"..
                            S("Events of flags") .."\n"..
                            "==================================================\n\n"..
                            S("A player has just triggered the flag")..":\n"..
                            core.formspec_escape("{\n"..
                            "    action = \"triggered\",\n"..
                            "    player_name = <").. S("Name of the player")..core.formspec_escape(">,\n"..
                            "    flags = {\n"..
                            "        triggered = <").. S("Number of triggered flags")..core.formspec_escape(">,\n"..
                            "        total = <").. S("Total number of flags")..core.formspec_escape(">\n"..
                            "    }\n"..
                            "}\n")..
                            "\n"..
                            "==================================================\n"..
                            S("Events of quest machines") .."\n"..
                            "==================================================\n\n"..
                            S("A player has just started the quest")..":\n"..
                            core.formspec_escape("{\n"..
                            "    action = \"quest_started\",\n"..
                            "    player_name = <").. S("Name of the player")..core.formspec_escape(">,\n"..
                            "}\n")..
                            "\n"..
                            S("A player has just received the reward")..":\n"..
                            core.formspec_escape("{\n"..
                            "    action = \"quest_started\",\n"..
                            "    player_name = <").. S("Name of the player")..core.formspec_escape(">,\n"..
                            "    completion = <").. S("Number of current completion")..core.formspec_escape(">\n"..
                            "}\n")

local formspec_guide =
        "formspec_version[4]" ..
        "size[11,12]" ..
        "style_type[label;font=mono,bold;font_size=32]" ..
        "style_type[textarea;font=mono]" ..
        "label[1.5,0.8;SuperQuest Digiline Guide]" ..
        "textarea[0.5,1.5;10,9;;;"..formspec_guide_text.."]" ..
        "button_exit[0.5,11;10,0.8;close;"..S("Close").."]"

function superquest.digilines.open_guide_formspec(player_name)
    core.show_formspec(player_name, guide_form_name, formspec_guide)
end

local function send_message(pos, channel, msg)
    digilines.receptor_send(pos, digilines.rules.default, channel, msg)
end

function superquest.digilines.send.flag_triggered(pos, channel, player_name, triggered, total)
    local msg = {
        action = "triggered",
        player_name = player_name,
        flags = {
            triggered = triggered,
            total = total
        }
    }
    send_message(pos, channel, msg)
end

function superquest.digilines.send.quest_started(pos, channel, player_name)
    local msg = {
        action = "quest_started",
        player_name = player_name
    }
    send_message(pos, channel, msg)
end

function superquest.digilines.send.reward_received(pos, channel, player_name, completion)
    local msg = {
        action = "reward_received",
        player_name = player_name,
        completion = completion
    }
    send_message(pos, channel, msg)
end
